# Use compreensão de listas e dicionários para:

# Converter uma lista de temperaturas dadas em Fahrenheit para Celsius.
# Lembre-se que C = ((F - 32) * 5) / 9.
temperaturas_f = [0.0, 104.0, 37.8, 56.9]
temperaturas_c = [(x - 32) * 5 / 9 for x in temperaturas_f]


# Fazer uma lista dos números primos menores ou iguais a um n dado.
def primo(p):
    if p < 2:
        return False
    for d in range(2, p - 1):
        if p % d == 0:
            return False
    return True


numeros = [2, 3, 1, 0, 5, 9, 13, 15, 18]
lista_p = [x for x in numeros if primo(x)]


# Pegar uma lista de strings que inclui palavras e números, e obter uma lista
# de inteiros apenas das strings que representam números não negativos.
# Dica: use o método isdecimal de str.

lista = ["mc", "102", "2023", "IC", "Unicamp", "-37"]
numeros = [int(x) for x in lista if x.isdecimal()]

# Repita o exercício anterior para números inteiros quaisquer.


def e_numero(string):
    return string.isdecimal() or \
        (len(string) > 0
         and string[0] == "-"
         and string[1:].isdecimal())


numeros2 = [int(x) for x in lista if e_numero(x)]

# Fazer um dicionário que representa um histograma de uma lista
# (Dica: use o método count de list)

dados = [1, 3, 4, 5, 1, 2, 3, 4, 6, 1, 8, 9, 10]
hist = {x: dados.count(x) for x in set(dados)}

# Criar uma matriz n por m com valor zero em cada entrada.
m = 5
n = 3
matriz = [[0 for i in range(m)] for j in range(n)]

# Criar uma matriz n por m com valores sequencias começando em 1 da esquerda
# para direita, de cima para baixo.

matriz = [[i * m + j + 1 for i in range(m)] for j in range(n)]
